;STATES.ASM
;
;*******************************************************************************
;*REVISION HISTORY:
;*
;*DATE             	REV. NO.      DESCRIPTION
;*
;*September 16, 2017	1.00          Adapt9S12P128 Demo
;*
;*
;*Author: Exequiel Rarama for the Adapt9S12P Demo
;*******************************************************************************
;
;Compiled CW5.1/5.2
;
; ---------------------------
; Demo - State Routine
; ---------------------------

	include derivative.inc

;Public Function
	XDEF ProcessCommand
	XDEF ShowMenu
	XDEF goPower 
	
	XDEF SendDecByte            ;Send out converted HEX
	XDEF HTOD

  XDEF SendLF_CR
  
;Public Variables
	XDEF state
	XDEF state_timer
	XDEF CrlfStr
	
;External Function
	XREF SerOutput0
	XREF OutStr0

	XREF PlayAudioInit
	XREF BeepingDisabled

;External Variables

	XREF Command
	XREF CommandFlg
	
	XREF ad0
	XREF ad1
	XREF ad2
	XREF ad3


; variable/data section
MY_EXTENDED_RAM: SECTION
; Insert here your data definition.
* System Variables

state:		ds	2
state_timer:	ds	2
temp:		ds	1
Var:		ds	2
DBUFR:		ds	5


CR:             equ     $D
LF:             equ     $A
SPACE:          equ     $20


***************************** Program *******************************

; code section
NON_BANKED:SECTION

goPower:
		movw	#goReady,state		;Loop here until something to do
		movw	#0,state_timer
            
goReady:
		rts


;-----------------------------
;Choose which one to process

ProcessCommand:
		ldaa	CommandFlg		;commands received via SCI interrupt
		lbeq	ProcessCommandEx	  
		clr	CommandFlg

		ldaa	Command
		anda	#$df			;simple convert to upper case (only works for alpha char)

		cmpa	#'A'
		lbeq	PCA

		cmpa	#'B'
		lbeq	PCB

		cmpa	#'C'
		lbeq	PCC

		cmpa	#'D'
		lbeq	PCD

		cmpa	#'E'
		lbeq	PCE

		cmpa	#'F'
		lbeq	PCF

		cmpa	#'G'
		lbeq	PCG

		cmpa	#'H'
		lbeq	PCH

		cmpa	#'I'
		lbeq	PCI

		cmpa	#'J'
		lbeq	PCJ

		cmpa	#'K'
		lbeq	PCK

		cmpa	#'L'
		lbeq	PCL
 
		cmpa	#'M' 
		lbeq	PCM

		cmpa	#'N' 
		lbeq	PCN

		cmpa	#'O' 
		lbeq	PCO

		cmpa	#'P' 
		lbeq	PCP

		cmpa	#'Q' 
		lbeq	PCQ

		cmpa	#'R' 
		lbeq	PCR_

		cmpa	#'S' 
		lbeq	PCS

		cmpa	#'T' 
		lbeq	PCT

		cmpa	#'U' 
		lbeq	PCU

		cmpa	#'V' 
		lbeq	PCV

		cmpa	#'W' 
		lbeq	PCW

		cmpa	#'X' 
		lbeq	PCX

		cmpa	#'Y' 
		lbeq	PCY

		cmpa	#'Z' 
		lbeq	PCZ
            
ShowMenu:
		ldx	#MenuMSG		;Send Menu message
		jsr	OutStr0

ShowPrompt:
		ldx	#PromptMSG
		jsr	OutStr0

ProcessCommandEx:
		rts

;-----------------------------------------------------
SendLF_CR:
		ldx	#CrlfStr	
		jsr	OutStr0			;Send string out to SCI0
		rts



PCA:
		ldy	#PCCA
		jmp	0,y

PCB:
		ldy	#PCCB
		jmp	0,y

PCC:
		ldy	#PCCC
		jmp	0,y

PCD:
		ldy	#PCCD
		jmp	0,y

PCE:
		ldy	#PCCE
		jmp	0,y

PCF:
		ldy	#PCCF
		jmp	0,y

PCG:
		ldy	#PCCG
		jmp	0,y

PCH:
		ldy	#PCCH
		jmp	0,y

PCI:
		ldy	#PCCI
		jmp	0,y

PCJ:
		ldy	#PCCJ
		jmp	0,y

PCK:
		ldy	#PCCK
		jmp	0,y

PCL:
		ldy	#PCCL
		jmp	0,y

PCM:
		ldy	#PCCM
		jmp	0,y

PCN:
		ldy	#PCCN
		jmp	0,y

PCO:
		ldy	#PCCO
		jmp	0,y

PCP:
		ldy	#PCCP
		jmp	0,y

PCQ:
		ldy	#PCCQ
		jmp	0,y

PCR_:
		ldy	#PCCR
		jmp	0,y

PCS:
		ldy	#PCCS
		jmp	0,y

PCT:
		ldy	#PCCT
		jmp	0,y

PCU:
		ldy	#PCCU
		jmp	0,y

PCV:
		ldy	#PCCV
		jmp	0,y

PCW:
		ldy	#PCCW
		jmp	0,y

PCX:
		ldy	#PCCX
		jmp	0,y

PCY:
		ldy	#PCCY
		jmp	0,y

PCZ:
		ldy	#PCCZ
		jmp	0,y



;--------------------------------------------------------------------
;Commands executed
PCCA:
		jsr	PlayAudioInit
		rts

PCCB:
		jsr	BeepingDisabled
		rts

PCCC:
		ldx	#M_PORT0AD
		jsr	OutStr0
		ldab	PT0AD
		jsr	SendDecByte

		ldx	#CrlfStr
		jsr	OutStr0

		ldx	#M_PORT1AD
		jsr	OutStr0

		ldab	PT1AD
		jsr	SendDecByte
		ldx	#CrlfStr
		jsr	OutStr0
            
            
		rts

PCCD:
		ldx	#M_PORTT
		jsr	OutStr0
		ldab	PTT
		jsr	SendDecByte

		ldx	#CrlfStr
		jsr	OutStr0
		rts

PCCE:
		ldx	#M_PORTM
		jsr	OutStr0
		ldab	PTM
		jsr	SendDecByte

		ldx	#CrlfStr
		jsr	OutStr0
		rts

PCCF:
		ldx	#M_PORTA
		jsr	OutStr0
		ldab	PORTA
		jsr	SendDecByte

		ldx	#CrlfStr
		jsr	OutStr0
		rts

PCCG:
		ldx	#M_PORTB
		jsr	OutStr0
		ldab	PORTA
		jsr	SendDecByte

		ldx	#CrlfStr
		jsr	OutStr0
		rts

PCCH:
		ldx	#M_PORTE
		jsr	OutStr0
		ldab	PORTE
		jsr	SendDecByte

		ldx	#CrlfStr
		jsr	OutStr0
		rts

PCCI:
		ldx	#M_PORTP
		jsr	OutStr0
		ldab	PTP
		jsr	SendDecByte

		ldx	#CrlfStr
		jsr	OutStr0
		rts

PCCJ:				
		ldx	#M_PORTJ
		jsr	OutStr0
		ldab	PTJ
		jsr	SendDecByte

		ldx	#CrlfStr
		jsr	OutStr0
		rts

PCCK:				
		ldx	#M_PORTS
		jsr	OutStr0
		ldab	PTS
		jsr	SendDecByte

		ldx	#CrlfStr
		jsr	OutStr0
		rts


PCCL:				

PCCM:				

PCCN:				

PCCO:

PCCP:

PCCQ:

PCCR:

PCCS:

PCCT:

PCCU:
		rts

PCCV:
		movw	#ShowAnalog,state		            ;Loop here until something to do
		movw	#0,state_timer
		ldx	#CrlfStr
		jsr	OutStr0
		rts

PCCW:
		movw	#goReady,state		              ;Loop here until something to do
		movw	#0,state_timer
		ldx	#CrlfStr
		jsr	OutStr0
		rts
            
PCCX:
		rts


PCCY:
		rts

PCCZ:
		rts

            


;------------------------------------------------
;Show Analog values
ShowAnalog:
		ldx	state_timer
		bne	ShowAnalogEx

		ldx	#M_AD0
		jsr	OutStr0
		ldx	#ad0
		jsr	HTOD

		ldx	#M_AD1
		jsr	OutStr0
		ldx	#ad1
		jsr	HTOD

		ldx	#M_AD2
		jsr	OutStr0
		ldx	#ad2
		jsr	HTOD

		ldx	#M_AD3
		jsr	OutStr0
		ldx	#ad3
		jsr	HTOD

		ldaa	#SPACE
		jsr	SerOutput0

		ldaa	#CR
		jsr	SerOutput0
            
		movw	#1953/8, state_timer
            
ShowAnalogEx:
		rts
                          


;-------------------------------------------------------
;Conversion routine
;
SendDecByte:                                        ;value is in B
		clra
		jsr	HexByte2Dec
		ldaa	DBUFR+0
		adda	#'0'
		jsr	SerOutput0
		ldaa	DBUFR+1
		jsr	SendASCIIHex
		rts

HexByte2Dec:                                       ;Supply hex value to be converted in B register
		clra
		ldx	#100                         ;numerator in D, denominator in X
		idiv                                   ; remainder in D, quotient in X
                                                   ;B is lo-order byte
		xgdx
		stab	DBUFR+0                      ;8 bit quotient in B
		xgdx
		ldx	#10                          ;H=0X  TO=packed BCD
		idiv
		stab	DBUFR+1
		xgdx
		aslb
		aslb
		aslb
		aslb
		orab	DBUFR+1
		stab	DBUFR+1
		rts

SendASCIIHex:                                      ;value in A
		psha
		anda	#$F0
		lsra
		lsra
		lsra
		lsra
		cmpa	#$0A
		blt	SAH1
		suba	#$0A
		adda	#'A'
		bra	SAH2
SAH1:
		adda	#'0'
SAH2:
		jsr	SerOutput0
		pula
		psha
		anda	#$0F
		cmpa	#$0A
		blt	SAH3
		suba	#$0A
		adda	#'A'
		bra	SAH4
SAH3
		adda	#'0'
SAH4
		jsr	SerOutput0
		pula
		rts



;==============================================================================
;-----------------------------------------------------------------------------
;HTOD-SUBROUTINE TO CONVERT A 16-BIT HEX NUMBER TO A 5 DIGIT DECIMAL
;This routine is taken from the HC11 manual.
;D=HEX VALUE TO BE CONVERTED
;X=ADDRESS WHERE THE NUMBER IS STORED TO BE CONVERTED

HTOD:
		LDD	0,X             ;
		LDX	#10000
		IDIV                    ;
		XGDX
		ADDB	#$30
		STAB	DBUFR
		XGDX
		LDX	#1000
		IDIV
		XGDX
		ADDB	#$30
		STAB	DBUFR+1
		XGDX
		LDX	#100
		IDIV
		XGDX
		ADDB	#$30
		STAB	DBUFR+2
		XGDX
		LDX	#10
		IDIV
		ADDB	#$30
		STAB	DBUFR+4
		XGDX
		ADDB	#$30
		STAB	DBUFR+3
		LDX	#DBUFR+1        ;POINT AT DECIMAL
		BRA	P1K

P5DEC:
		LDX	#DBUFR          ;POINT AT DECIMAL
		LDAA	#$30            ;CHECK FOR LEADING ZEROS
		CMPA	0,X             ;CHECK FOR 10,000S DIGIT

		BNE	P10K            ;START AT 10K DIGIT
		BSR	SKP1            ;INX AND PRINT A SPACE
		CMPA	0,X             ;CHECK FOR 1,000S

		BNE	P1K             ;START AT 1K DIGIT
		BSR	SKP1
		BSR	SKP1
		DEX
		CMPA	0,X             ;CHECK FOR 100S DIGIT

		BNE	P100            ;START AT 100 DIGIT
		BSR	SKP1
		CMPA	0,X             ;CHECK 10S DIGIT

		BNE	P10
		BSR	SKP1
		BRA	P1              ;START AT 1S DIGIT

P10K:
		LDAA	0,X             ;10,000 DIGIT
		PSHX
		jsr	SerOutput0
		PULX
		INX

P1K:
		LDAA	0,X
		PSHX
		jsr	SerOutput0
		PULX
		INX

P100: 
		LDAA	0,X
		PSHX
		jsr	SerOutput0
		PULX
		INX

P10:        
		LDAA	0,X
		PSHX
		jsr	SerOutput0
		PULX
		INX

P1:
		LDAA	0,X
		jsr	SerOutput0
		RTS

SKP1:
		PSHA
		INX
		LDAA	#$20
		jsr	SerOutput0
		PULA
		RTS


*******************************************************************************
* Messages

MenuMSG:
		dc.b	$D,$A
		dc.b	'----------------------------------------------------',$D,$A
		dc.b	'  Technological Arts - Adapt9S12P128 Demo V1.00   ',$D,$A
		dc.b	'----------------------------------------------------',$D,$A
		dc.b	$D,$A
					
		dc.b	'A => Toggle ON LED/Audio - Port J bit 2',$D,$A
		dc.b	'B => Turn OFF LED/Audio  - Port J bit 2',$D,$A
		
		
		dc.b	'C => SHOW PORT AD0 and 1 STATUS',$D,$A
		dc.b	'D => SHOW PORT T STATUS',$D,$A
		dc.b	'E => SHOW PORT M STATUS',$D,$A
		dc.b	'F => SHOW PORT A STATUS',$D,$A
		dc.b	'G => SHOW PORT B STATUS',$D,$A
		dc.b	'H => SHOW PORT E STATUS',$D,$A
		dc.b	'I => SHOW PORT P STATUS',$D,$A
		dc.b	'J => SHOW PORT J STATUS',$D,$A
		dc.b	'K => SHOW PORT S STATUS',$D,$A
						
		dc.b	'V => SHOW 12-bit REAL-TIME ANALOG VALUES',$D,$A,$D,$A
		dc.b	'W => STOP SHOWING AD VALUES',$D,$A


		dc.b	0			;Termination					

PromptMSG:	dc.b    '?',0
CrlfStr:	dc.b     CR,LF,$0


M_AD0:		dc.b	'AD0=',0
M_AD1:		dc.b	' AD1=',0
M_AD2:		dc.b	' AD2=',0
M_AD3:		dc.b	' AD3=',0

M_AD4:		dc.b	' AD4=',0
M_AD5:		dc.b	' AD5=',0
M_AD6:		dc.b	' AD6=',0
M_AD7:		dc.b	' AD7=',0

M_PORT0AD:	dc.b	'PORT0AD=',0
M_PORT1AD:	dc.b	'PORT1AD=',0
M_PORTT:	dc.b	'PORTT=',0
M_PORTM:	dc.b	'PORTM=',0
M_PORTA:	dc.b	'PORTA=',0
M_PORTB:	dc.b	'PORTB=',0
M_PORTE:	dc.b	'PORTE=',0
M_PORTP:	dc.b	'PORTP=',0

M_PORTS:	dc.b	'PORTS=',0
M_PORTJ:	dc.b	'PORTJ=',0

            END
